//-----------------------------------------------------------------------------
// Function-prototypes
//-----------------------------------------------------------------------------

LRESULT CALLBACK MainWndProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
INT_PTR CALLBACK OptionsDlgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
VOID ShowContextMenu();
BOOL SaveSettings();
BOOL LoadSettings();
BOOL ShowAboutBox();
BOOL ShowOptions();
DWORD WINAPI UpdateLoop(LPVOID lpNULL);
BOOL RefreshState();
BOOL GetJoyCapabilities();
void PopulateCombo(int ID, int sel);
void PopulateCombos(void);
void ButtonAction(int action, bool pressed);
void UnsetAction(int action, int exclude);
void Enable(bool enable);
HINSTANCE GotoURL(LPCTSTR url, int showcmd);
LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);


//-----------------------------------------------------------------------------
// Defines, constants, and global variables
//-----------------------------------------------------------------------------
#include "ztray.h"
#include "registry.h"
#include <commctrl.h>
#include <Mmsystem.h>

// Macros
#define WM_TRAY WM_USER+1

#define ACTION_NONE 0
#define ACTION_LEFT_CLICK 1
#define ACTION_MIDDLE_CLICK 2
#define ACTION_RIGHT_CLICK 3
#define ACTION_DOUBLE_CLICK 4
#define ACTION_ACCEL 5
#define ACTION_DISABLE 6

#define BUTTON_COUNT 8


// Registry Key
const	LPCTSTR g_pszKey = "Software\\Phatsoft\\JoyMouse";

// Update Loop
bool g_bUpdateLoop = true;

// Joystick parameters
JOYCAPS g_jc;
DWORD g_Pool = 10;
DWORD g_Speed = 2;
DWORD g_Speed2 = 15;
DWORD g_Step = 1;
DWORD g_EnableAtLaunch = true;

int g_Button_Data[] = {
	JOY_BUTTON1, 1, IDC_COMBO_BUTTON_1, IDC_RADIO_B1,
	JOY_BUTTON2, 2, IDC_COMBO_BUTTON_2, IDC_RADIO_B2,
	JOY_BUTTON3, 3, IDC_COMBO_BUTTON_3, IDC_RADIO_B3,
	JOY_BUTTON4, 4, IDC_COMBO_BUTTON_4, IDC_RADIO_B4,
	JOY_BUTTON5, 5, IDC_COMBO_BUTTON_5, IDC_RADIO_B5,
	JOY_BUTTON6, 6, IDC_COMBO_BUTTON_6, IDC_RADIO_B6,
	JOY_BUTTON7, 0, IDC_COMBO_BUTTON_7, IDC_RADIO_B7,
	JOY_BUTTON8, 0, IDC_COMBO_BUTTON_8, IDC_RADIO_B8
};

// Tray Icon
ZTray *g_TrayIcon;
bool g_bGrayed = true;

// Handles
HINSTANCE g_hInst = NULL;
HWND g_hwndMain = NULL;
HWND g_hwndOptions = NULL;

// Mouse buttons
bool g_bLeftDown = false;
bool g_bMiddleDown = false;
bool g_bRightDown = false;
bool g_bDoubleDown = false;
bool g_bAccel = false;
bool g_bEnableButton = false;
bool g_bEnabled = true;